#define pre "LC_"
#define sl "Stop-Loss-In-Points"
#define sr "Percentage-Of-Account-To-Use"
#property show_inputs
extern double STOP_LOSS_POINTS = 9.0;
extern double ACCOUNT_PERCENTAGE_RISK = 0.9;

void deinit() {GlobalVariablesDeleteAll(pre);return;}

void start() {
   if(!GlobalVariableCheck(pre+sl))
    GlobalVariableSet(pre+sl,STOP_LOSS_POINTS);
   if(!GlobalVariableCheck(pre+sr))
    GlobalVariableSet(pre+sr,ACCOUNT_PERCENTAGE_RISK);
   double Lots = LotsCalc(Symbol(),GlobalVariableGet(pre+sl),GlobalVariableGet(pre+sr));
   if(Lots>0.0) string txt=
    " ~ ~ Works for Forex pairs only ~ ~ "+
    "\n StopLoss: "+DoubleToStr(GlobalVariableGet(pre+sl),1)+
    " , AccRisk: "+DoubleToStr(GlobalVariableGet(pre+sr),1)+
    "  --> LOTS   [  "+DoubleToStr(Lots,2)+"  ]"+
    ""; 
   else txt="Some error occurred in lots calculating";
   Comment(txt);
   return; }
   
/*****  does not work on indices, it is for forex only ******/
double LotsCalc ( string sy , double StopLoss = 0 , double AccountRisk = 1 ) {
 double funds = MathMin ( AccountBalance() , AccountEquity() );
   if ( AccountStopoutMode() == 0 )
   funds -= 0.01 * AccountStopoutLevel() * MathMax ( AccountBalance() , AccountEquity() );
   if ( AccountStopoutMode() == 1 ) funds -= AccountStopoutLevel();
   funds -= AccountMargin();
   if ( ! ( funds > 0.0 ) ) return(0);
   double lotd = MarketInfo ( sy , 32 );
   if ( ! ( lotd > 0.0 ) ) return(0);
   double available = funds / lotd,
   minl = MarketInfo ( sy , 23 );
   if ( available < minl ) return(0);
   double maxl = MarketInfo ( sy , 25 ),
   pval = MarketInfo ( sy , 16 ),
   stepl = MarketInfo ( sy , 24 ),
   spr = MarketInfo ( sy , 10 ) - MarketInfo ( sy , 9 ),
   dig = MarketInfo ( sy , 12 ),
   pnt = MarketInfo ( sy , 11 );
   if ( ! ( maxl > 0.0 ) ) maxl = 999999;
   if ( dig < 4 ) pnt = 0.01;
   if ( dig > 3 ) pnt = 0.0001;
   double costrisk = ( spr / pnt + StopLoss ) * available * pval + funds;
   if ( available / costrisk * funds < minl ) return(0);
   if ( ! ( stepl > 0.0 ) ) stepl = minl;
   double free = funds / lotd / costrisk * funds *0.01* AccountRisk;
   int tmp = free / stepl;
   double lot = MathMin ( maxl , MathMax ( tmp * stepl , minl ) );
   return ( lot );  }
   